From 99c992a9e16efaf7366b6022996d9da2006a1e22 Mon Sep 17 00:00:00 2001
From: Dhriti Shikhar <dhrish20@gmail.com>
Date: Feb 21 2016 12:16:46 +0000
Subject: [PATCH 297/1001] Adds a bugzilla widget


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 3856d78..a0a2641 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -66,4 +66,10 @@ def add_user_widgets(session, hub, username, fullname):
             'display_number': 15,
         }))
     hub.widgets.append(widget)
+    widget = hubs.models.Widget(
+        plugin='bugzilla', index=8,
+        _config=json.dumps({
+            'username': username,
+        }))
+    hub.widgets.append(widget)
     return hub
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 03084ac..cc7007c 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -14,6 +14,7 @@ from hubs.widgets import pagure_pr
 from hubs.widgets import github_pr
 from hubs.widgets import pagureissues
 from hubs.widgets import githubissues
+from hubs.widgets import bugzilla
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -37,6 +38,7 @@ registry = {
     'github_pr': github_pr,
     'pagureissues': pagureissues,
     'githubissues': githubissues,
+    'bugzilla': bugzilla,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/bugzilla.py b/hubs/widgets/bugzilla.py
new file mode 100644
index 0000000..b8d2d5a
--- /dev/null
+++ b/hubs/widgets/bugzilla.py
@@ -0,0 +1,81 @@
+import operator
+import requests
+from hubs.hinting import hint, prefixed as _
+from hubs.widgets.base import argument
+import jinja2
+import hubs.validators as validators
+from hubs.widgets.chrome import panel
+import pkgwat.api
+
+chrome = panel("Bugzilla: Issues")
+
+template = jinja2.Template("""
+  {% for i in range(0,3) %}
+  <br />
+  <div class="container">
+    <table class="table-responsive table-condensed">
+      <tr>
+        <td valign="top" class="panel-heading">
+          <b>{{ all_issues[i]['issue_title'] }}</b>
+        </td>
+      </tr>
+    </table>
+    <table class="table-responsive table-condensed">
+      <tr>
+        <td>
+          <font size="2"><i>package: </i></font>
+        </td>
+        <td>
+          <font size="2"><i><a href="https://admin.fedoraproject.org/pkgdb/package/rpms/{{ all_issues[i]['pkg_name'] }}" target="_blank">{{ all_issues[i]['pkg_name'] }}</a></i></font>
+        </td>
+      </tr>
+    </table>
+  </div>
+  {% endfor %}
+""")
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+    username=username
+    pkgdb_url = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
+    url = "/".join([pkgdb_url, username])
+    response = requests.get(url)
+    data = response.json()
+    total_poc = len(data["point of contact"])
+    total_co_main = len(data["co-maintained"])
+    
+    all_issues = list()
+    
+    for package in data["point of contact"]:
+      pkg_details=pkgwat.api.bugs(package['name'])
+      total_issues=pkg_details['total_rows']
+      for i in range(0,total_issues):
+        all_issues.append(
+          dict(
+            pkg_name=package['name'],
+            issue_title=pkg_details['rows'][i]['description'],
+          )
+        ) 
+      
+    for package in data["co-maintained"]:
+      pkg_details=pkgwat.api.bugs(package['name'])
+      total_issues=pkg_details['total_rows']
+      for i in range(0,total_issues):
+        all_issues.append(
+          dict(
+            pkg_name=package['name'],
+            issue_title=pkg_details['rows'][i]['description'],
+          )
+        )
+
+    return dict(
+      username=username,
+      all_issues=all_issues,
+    )
+
+@hint()
+def should_invalidate(message, session, widget):
+    raise NotImplementedError

